package edu.sfedu.brsback.controllers;

import edu.sfedu.brsback.dto.auth.AuthCredentials;
import edu.sfedu.brsback.dto.auth.JwtResponse;
import edu.sfedu.brsback.services.SecurityService;
import lombok.AllArgsConstructor;
import lombok.RequiredArgsConstructor;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/auth")
@RequiredArgsConstructor
public class AuthController {
    private final SecurityService securityService;
    @PostMapping("/login")
    public JwtResponse login(@RequestBody AuthCredentials creds){
        var token = securityService.login(creds);
        return new JwtResponse(token);
    }
}
