package edu.sfedu.brsback.controllers;


import edu.sfedu.brsback.dto.base.ListResponse;
import edu.sfedu.brsback.dto.recordbook.RecordBookDto;
import edu.sfedu.brsback.entities.RecordBook;
import edu.sfedu.brsback.repos.RecordBookRepository;
import lombok.NonNull;
import lombok.RequiredArgsConstructor;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/record-book")
@RequiredArgsConstructor
public class RecordBookController {
    private final RecordBookRepository recordBookRepository;

    @GetMapping()
    public ResponseEntity<ListResponse<RecordBookDto>> getRecordBooksOfStudent(
            @RequestParam("student_user_id") @NonNull Long studentUserId
    ) {
        var result = recordBookRepository.findByStudentUserId(studentUserId);
        return ResponseEntity.ok(new ListResponse<>(
                result.stream().map(RecordBookDto::new).toList()
        ));
    }
}
