package edu.sfedu.brsback.controllers.employee.teacher;

import edu.sfedu.brsback.dto.score.ScoreSetDto;
import edu.sfedu.brsback.services.ScoreService;
import edu.sfedu.brsback.utils.auth.TeacherAuth;
import jakarta.validation.Valid;
import lombok.RequiredArgsConstructor;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

@RestController
@RequestMapping("/teacher/score")
@RequiredArgsConstructor
@TeacherAuth
public class ScoreController {
    private final ScoreService scoreService;
    @PutMapping("set")
    public ResponseEntity<?> setScore(
            @Valid @RequestBody ScoreSetDto scoreSetDto
    ) {
        try {
            scoreService.setScore(scoreSetDto);
        }
        catch (Throwable e){
            return ResponseEntity.badRequest().body(Map.of("error", "ERROR.ERROR_WITH_SETTING_SCORE"));
        }

        return ResponseEntity.status(HttpStatus.CREATED).build();
    }
}
