package edu.sfedu.brsback.entities;

import edu.sfedu.brsback.enums.EventType;
import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.util.UUID;

@Getter
@Setter
@Entity
@Table(name = "event_log")
@AllArgsConstructor
@NoArgsConstructor
public class EventLog extends BaseEntity {
    @Id
    @GeneratedValue(strategy = GenerationType.UUID)
    @Column(name = "id", nullable = false)
    private UUID id;

    @Enumerated
    @Column(name = "event_type")
    private EventType eventType;

    @ManyToOne(cascade = CascadeType.REMOVE)
    @JoinColumn(name = "teacher_id")
    private User teacher;

    @ManyToOne(cascade = CascadeType.REMOVE)
    @JoinColumn(name = "module_id")
    private Module module;

    @ManyToOne(cascade = CascadeType.REMOVE)
    @JoinColumn(name = "record_book_id")
    private RecordBook recordBook;

    public EventLog(Score score, User teacher) {
        this.teacher = teacher;

        if (score.getId() == null){
            eventType = EventType.SCORE_CREATED;
        }
        else{
            eventType = EventType.SCORE_CREATED;
        }
        module = score.getModule();
        recordBook = score.getRecordBook();
    }

    public EventLog(Visit visit, User teacher) {
        this.teacher = teacher;
        eventType = EventType.VISIT_CREATED;
        module = visit.getModule();
        recordBook = visit.getRecordBook();
    }
}