package edu.sfedu.brsback.entities;

import jakarta.persistence.*;
import lombok.Getter;
import lombok.Setter;

import java.util.LinkedHashSet;
import java.util.Set;

@Getter
@Setter
@Entity
@Table(name = "record_book")
public class RecordBook extends BaseEntity {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", nullable = false)
    private Long id;

    @Column(name = "title", unique = true, length = 20)
    private String title;

    @ManyToOne(cascade = CascadeType.REMOVE)
    @JoinColumn(name = "user_id")
    private User user;

    @OneToMany(mappedBy = "recordBook", orphanRemoval = true)
    private Set<EventLog> eventLogs = new LinkedHashSet<>();

    @OneToMany(mappedBy = "recordBook", cascade = CascadeType.REMOVE, orphanRemoval = true)
    private Set<ModuleRight> moduleRights = new LinkedHashSet<>();

}