package edu.sfedu.brsback.entities;

import jakarta.persistence.*;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@Entity
@Table(name = "score")
@NoArgsConstructor
public class Score extends BaseEntity {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", nullable = false)
    private Long id;

    @Column(name = "score")
    private Integer score;

    @ManyToOne(cascade = CascadeType.REMOVE)
    @JoinColumn(name = "record_book_id")
    private RecordBook recordBook;

    @ManyToOne(cascade = CascadeType.REMOVE)
    @JoinColumn(name = "module_id")
    private Module module;

    public Score(Integer score, RecordBook recordBook, Module module) {
        this.score = score;
        this.recordBook = recordBook;
        this.module = module;
    }
}