package edu.sfedu.brsback.entities;

import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.time.LocalDate;

@Getter
@Setter
@Entity
@Table(name = "visit")
@AllArgsConstructor
@NoArgsConstructor
public class Visit extends BaseEntity {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", nullable = false)
    private Long id;

    @Column(name = "date")
    private LocalDate date;

    @ManyToOne(cascade = CascadeType.REMOVE)
    @JoinColumn(name = "module_id")
    private Module module;

    @ManyToOne(cascade = CascadeType.REMOVE)
    @JoinColumn(name = "record_book_id")
    private RecordBook recordBook;

    public Visit(LocalDate date, Module module, RecordBook recordBook){
        this.date = date;
        this.module = module;
        this.recordBook = recordBook;
    }

}