package edu.sfedu.brsback.exceptions;

import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;

import java.util.Map;

@ControllerAdvice
public class BaseExceptionHandler {

    @ExceptionHandler(Throwable.class)
    public ResponseEntity<?> handleOtherExceptions(Throwable th){
        return ResponseEntity
                .internalServerError()
                .body(
                        Map.of(
                                "error", th.getMessage(),
                                "trace", th.getStackTrace()
                        )
                );
    }

}
