package edu.sfedu.brsback.listeners.eventlog;

import edu.sfedu.brsback.entities.EventLog;
import edu.sfedu.brsback.events.eventlog.ScoreEdited;
import edu.sfedu.brsback.events.eventlog.VisitCreated;
import edu.sfedu.brsback.events.eventlog.VisitCreatedPublisher;
import edu.sfedu.brsback.repos.EventLogRepository;
import lombok.RequiredArgsConstructor;
import org.jetbrains.annotations.NotNull;
import org.springframework.context.ApplicationListener;
import org.springframework.stereotype.Component;

@Component
@RequiredArgsConstructor
public class VisitCreatedListener implements ApplicationListener<VisitCreated> {
    private final EventLogRepository eventLogRepository;
    @Override
    public void onApplicationEvent(@NotNull VisitCreated event) {
        eventLogRepository.save(
                new EventLog(event.getVisit(), event.getTeacher())
        );
    }
}