package edu.sfedu.brsback.repos;

import edu.sfedu.brsback.dto.ModuleRightDto;
import edu.sfedu.brsback.entities.ModuleRight;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.Optional;
import java.util.UUID;

public interface ModuleRightRepository extends JpaRepository<ModuleRight, UUID> {

    @Query("select m from ModuleRight m where m.module.id = ?1 and m.user.id = ?2")
    Optional<ModuleRightDto> findDTOByModuleAndUser(Long moduleId, Long userId);

    @Query("select m from ModuleRight m where m.module.id = ?1 and m.recordBook.id = ?2")
    Optional<ModuleRightDto> findDTOByModuleAndRecordBook(Long moduleId, Long recordBookId);

    @Query("select m from ModuleRight m where m.module.id = ?1 and m.user.id = ?2")
    Optional<ModuleRight> findByModuleAndUser(Long moduleId, Long userId);

    @Query("select m from ModuleRight m where m.module.id = ?1 and m.recordBook.id = ?2")
    Optional<ModuleRight> findByModuleAndRecordBook(Long moduleId, Long recordBookId);
}