package edu.sfedu.brsback.services;

import edu.sfedu.brsback.dto.module.ModuleFilter;
import edu.sfedu.brsback.dto.module.ModuleMainData;
import edu.sfedu.brsback.entities.Module;
import edu.sfedu.brsback.entities.RecordBook;
import edu.sfedu.brsback.entities.User;

import java.util.Collection;
import java.util.Map;
import java.util.Optional;

public interface ModuleService {
    /**
     * Получить все модули с учётом фильтра
     *
     * @param filter ModuleFilter
     * @return Collection<Module>
     */
    Collection<Module> getAvaliableModules(ModuleFilter filter);

    /**
     * Получить модуль по ID
     *
     * @param moduleId Long
     * @return Collection<Module>
     */
    Module getModuleById(Long moduleId);

    /**
     * Сохранить модуль
     *
     * @param module     Module
     * @return void
     */
    void saveModule(Module module);

    /**
     * Удалить модуль по ID
     *
     * @param moduleId Long
     * @return boolean
     */
    boolean deleteModuleById(Long moduleId);
}
