package edu.sfedu.brsback.services;

import edu.sfedu.brsback.dto.auth.AuthCredentials;
import edu.sfedu.brsback.entities.User;

public interface SecurityService {
    /**
     * Авторизоваться и получить токен
     *
     * @return String
     */
    String login(AuthCredentials creds);

    /**
     * Получить авторизованного пользователя
     *
     * @return User
     */
    User getAuthUser();

    /**
     * Получить ID авторизованного пользователя
     *
     * @return Long
     */
    Long getAuthUserId();

    /**
     * Выйти из аккаунта
     *
     * @return Long
     */
    boolean logout();
}
